<?php
 
 $execute = false;
 $rs = query("desc dependencymap2");
 foreach ($rs["arr"] as $k => $v) {
 
 if ($v["Field"] === "dep_ele_id") {
 $execute = true;
 }
 } 
 
 if (!$execute) {
 exit("The dependencymap2 has already been updated - nothing to be updated.\n");
 }
 
 

 
 $rs = query("select * from dirtqueue where property = 'blocker' and obj_type is null and obj_id is null");
 if ($rs["num"] == 0) {
 
 echo "inserting blocker into dirtqueue\n";
 query("insert into dirtqueue (timestamp, property) values (unix_timestamp(), 'blocker')");
 } else {
 echo "not inserting blocker into dirtqueue (found one)\n";
 }

 
 $wait = true;
 while ($wait) {
 $rs = query("SELECT * FROM dirtqueue ORDER BY id ASC LIMIT 1");
 if ($rs["num"] == 0) {
 die("did not find the blocker anymore!");
 } else if ($rs["arr"][0]["property"] == "blocker") {
 $wait = false;
 } else {
 echo "still found dirtqueue entries\n";
 sleep(10);
 }
 }

 $start = time();

 
 echo "creating new dependencymap2 table\n";
 query("CREATE TABLE dependencymap2_new (
      id int(10) unsigned NOT NULL auto_increment,
      mod_obj_type int(10) unsigned default NULL,
      mod_obj_id int(10) unsigned default NULL,
      mod_ele_type int(10) unsigned default NULL,
      mod_ele_id int(10) unsigned default NULL,
      mod_prop varchar(255) default NULL,
      dep_obj_type int(10) unsigned default NULL,
      dep_obj_id int(10) unsigned default NULL,
      eventmask int(10) unsigned NOT NULL default '0',
      PRIMARY KEY (id),
      KEY mod_obj (mod_obj_type,mod_obj_id),
      KEY mod_ele (mod_ele_type,mod_ele_id),
      KEY dep_obj (dep_obj_type,dep_obj_id),
      KEY mod_obj_type (mod_obj_type,mod_obj_id,mod_ele_type,mod_ele_id,mod_prop)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8");

 
 echo "locking tables for WRITE\n";
 query("LOCK TABLES dependencymap2 WRITE, dependencymap2_new WRITE");
 
 
 echo "copying the data (this might take a while, so be patient)\n";
 query("insert into dependencymap2_new (id, mod_obj_type, mod_obj_id,
      mod_ele_type, mod_ele_id, mod_prop, dep_obj_type, dep_obj_id, eventmask)
      select id, mod_obj_type, mod_obj_id, mod_ele_type, mod_ele_id, mod_prop,
      dep_obj_type, dep_obj_id, eventmask from dependencymap2");

 
 echo "unlocking tables\n";
 query("UNLOCK TABLES");

 
 echo "dropping the old table\n";
 query("drop table dependencymap2");
 
 
 echo "renaming the new table\n";
 query("rename table dependencymap2_new to dependencymap2");
 
 
 echo "delete blocker from dirtqueue\n";
 query("delete from dirtqueue where property = 'blocker' and obj_type is null and obj_id is null");

 $duration = time() - $start;
 $hours = 0;
 $minutes = 0;
 $seconds = 0;

 if ($duration > 3600) {
 $hours = floor($duration / 3600);
 $duration -= $hours * 3600;
 }

 if ($duration > 60) {
 $minutes = floor($duration / 60);
 $duration -= $minutes * 60;
 }

 $seconds = $duration;
 
 echo "finished in $hours hours $minutes minutes $seconds seconds!\n";
?>
