<?php






function mydb_getcoldef($ctype,$db) {

 $sql = "";
 
 if ($db["type"] == "mysql" || $db["type"] == "ora") {
 $type = strtolower($ctype["type"]);
 if ($type == "int") { $sql .= "int"; }
 elseif (ereg("^char\(([0-9]*)\)$",$type,$reg)) { $sql .= "char(".sqlf_tl_num($reg[1]).")"; }
 elseif (ereg("^varchar\(([0-9]*)\)$",$type,$reg)) { 
 if ($db["type"] == "mysql") $sql .= "varchar(".sqlf_tl_num($reg[1]).")";
 else if ($db["type"] == "ora") $sql .= "varchar2(".sqlf_tl_num($reg[1]).")";
 else halt(7,"mydb_getcoldef: invalid dbtype");
 }
 elseif ($type == "text") { $sql .= "text"; }
 elseif ($type == "blob") {
 if ($db["type"] == "mysql") $sql .= "longblob";
 else $sql .= "blob";
 }
 elseif ($type == "longtext") { 
 if ($db["type"] == "mysql") $sql .= "mediumtext"; 
 elseif ($db["type"] == "ora") $sql .= "clob";
 else halt(7,"mydb_getcoldef: invalid dbtype");
 }
 elseif ($type == "float") { $sql .= "double"; }
 else halt(7,"mydb_getcoldef: unknown type. type($type)");
 if (isset($ctype["default"])) $sql .= " default '".sqlslashes($ctype["default"],$db)."'";
 if ($ctype["auto_increment"]) $sql .= " primary key auto_increment";
 if (!$ctype["null"]) $sql .= " not null";
 }

 return $sql;
}


function mydb_resolvecoltype($sql, $db) {
 $type = "";

 
 if ($db["type"] == "mysql" || $db["type"] == "ora") {
 if (ereg("^int|^tinyint|^smallint",$sql)) $type = "int";
 elseif (ereg("^char\(([0-9]*)\)$",$sql,$reg)) { $type = "char(".$reg[1].")"; }
 elseif (ereg("^varchar\(([0-9]*)\)$",$sql,$reg)) { $type = "varchar(".$reg[1].")"; }
 elseif ($sql == "text") { $type = "text"; }
 elseif ($sql == "blob") { $type = "blob"; }
 elseif ($sql == "longblob") { $type == "longblob"; }
 elseif ($sql == "mediumblob") { $type == "longblob"; }
 elseif ($sql == "mediumtext" || $sql == "clob") { $type = "longtext"; }

 
 elseif (ereg("^bigint\(([0-9]*)\)$",$sql,$reg)) { $type = "bigint(".$reg[1].")"; }
 elseif ($sql == "double") { $type == "double"; }
 elseif ($sql == "datetime") { $type == "datetime"; }
 else halt(7,"mydb_resolvecoltype: unknown type. type($sql)");
 
 }

 return $type;
}



function mydb_transformtodbdata($fieldDescription, $fieldValue, $db=false) {
 global $DB;
 $db = $db?$db:$DB;

 if ($db["type"] == "mysql") {
 
 if ( ($pos=strpos( $fieldDescription["type"], "(" )) !== false )
 {
 $type = substr( $fieldDescription["type"], 0, $pos );
 }
 else
 $type = $fieldDescription["type"];
 switch ( $type )
 {
 case "int":
 if ( is_numeric($fieldValue) )
 return $fieldValue;
 return NULL;
 case "text":
 case "char":
 case "varchar":
 case "longtext":
 return "'".sqlslashes($fieldValue)."'";
 case "blob":
 case "longblob":
 halt( 7, "mydb_transformtodbdata() - nyi: blob!" );
 }
 }

 return NULL;
}












function mydb_create_table($tabname, $cols, $db = false, $override = true) {
 global $DB;
 $db = ($db)?$db:$DB;

 if (!$tabname) halt(7,"mydb_create_table: no tabname tabname($tabname).");
 if (!is_array($cols)) halt(7,"mydb_create_table: cols is not an array. cols($cols).");

 
 if (($db["type"] == "mysql") && $override) {
 $sql = "DROP TABLE IF EXISTS ".sqlf_table($tabname);
 query($sql,$db);
 }

 $sql = "CREATE TABLE ".sqlf_table($tabname)." (";

 while (list($name,$type) = each($cols)) {
 $sql .= sqlf_field($name)." ".mydb_getcoldef($type,$db).",";
 }
 $sql = substr($sql,0,strlen($sql)-1);

 $sql .= ")";

 query($sql,$db);
}



function mydb_drop_table($tabname, $db = false) {
 global $DB;
 $db = ($db)?$db:$DB;

 if (!$tabname) halt(7,"mydb_drop_table: no tabname tabname($tabname).");

 if ($db["type"] == "mysql") {
 $sql = "DROP TABLE IF EXISTS ".sqlf_table($tabname);
 query($sql, $db);
 }
}



function mydb_add_column($tabname, $colname, $coltype, $db = false) {
 global $DB;
 $db = ($db)?$db:$DB;

 if (!$tabname) halt(7,"mydb_add_column: no tabname tabname($tabname).");
 if (!$colname) halt(7,"mydb_add_column: no colname colname($colname).");
 if (!is_array($coltype)) halt(7,"mydb_add column: coltype is not an array. coltype($coltype).");
 
 $sql = "ALTER TABLE ".sqlf_table($tabname)." ADD ".sqlf_field($colname)." ".mydb_getcoldef($coltype,$db);
 query($sql,$db);
}

function mydb_drop_column($tabname,$colname,$db = false) {
 global $DB;
 $db = ($db)?$db:$DB;

 $sql = "ALTER TABLE ".sqlf_table($tabname)." DROP COLUMN ".sqlf_field($colname);
 query($sql,$db);
}



function mydb_show_tables($db = false) {
 global $DB;
 $db = ($db)?$db:$DB;

 $tabs = array();
 $seqs = array();

 if ($db["type"] == "mysql") {
 $sql = "SHOW TABLES";
 $rs = query($sql,$db);

 while (list($key,$val) = each($rs["arr"])) {
 $tabs[] = $val[0];
 }
 }

 return array("tables" => $tabs, "sequences" => $seqs);
}


function mydb_table_exists($table, $db = false) {
 global $DB;
 $db = ($db)?$db:$DB;

 $tabs = mydb_show_tables($db);
 return in_array($table, $tabs["tables"]);
} 



function mydb_desc_table($tabname, $db = false, $onlycolnames = false, $cache = false) {
 global $DB, $MYDB_DESCTABLE_CACHE;
 $db = ($db)?$db:$DB;

 if ( !isset( $MYDB_DESCTABLE_CACHE ) )
 $MYDB_DESCTABLE_CACHE = array();
 
 if ( $cache && $MYDB_DESCTABLE_CACHE[$db["type"]] )
 {
 if ( $MYDB_DESCTABLE_CACHE[$db["type"]][$tabname] )
 return $MYDB_DESCTABLE_CACHE[$db["type"]][$tabname];
 }
 else
 $MYDB_DESCTABLE_CACHE[$db["type"]] = array();
 
 if (!$tabname) halt(7,"mydb_desc_table: no tabname tabname($tabname).");
 
 $res = array();
 
 if ($db["type"] == "mysql") {
 $sql = "DESC ".sqlf_table($tabname);
 $rs = query($sql, $db);
 while (list($key,$val) = each($rs["arr"])) {
 if (!$onlycolnames) {
 $res[$val["Field"]]["type"] = mydb_resolvecoltype($val["Type"],$db);;
 $res[$val["Field"]]["null"] = ($val["Null"])?true:false;
 $res[$val["Field"]]["default"] = $val["Default"];
 $res[$val["Field"]]["auto_increment"] = ($val["Extra"] == "auto_increment")?true:false;
 $res[$val["Field"]]["primary_key"] = ($val["Key"] == "PRI")?true:false;
 } else $res[$val["Field"]] = true;
 }
 } else if ($db["type"] == "ora") {
 $sql = "SELECT column_name FROM user_tab_columns WHERE table_name = '".sqlf_escaped(strtoupper($tabname))."'";
 $rs = query($sql,$db);
 while (list($k,$v) = each($rs["arr"])) {
 $res[$v["column_name"]] = true;
 $res[strtolower($v["column_name"])] = true;
 }
 }
 
 $MYDB_DESCTABLE_CACHE[$db["type"]][$tabname] = $res;
 return $res;;
}



function mydb_desc_index($tabname, $db = false) {
 global $DB;
 $db = ($db)?$db:$DB;
 
 $res = array();
 
 if ($db["type"] == "mysql") {
 $sql = "SHOW INDEX FROM ".sqlf_table($tabname);
 $rs = query($sql, $db);

 while (list($key,$val) = each($rs["arr"])) {
 $k = $val["Key_name"];
 if (!is_array($res[$k])) {
 $res[$k]["cols"] = array();
 $res[$k]["type"] = ($val["Non_unique"])?"key":"primary";
 }
 $res[$k]["cols"][$val["Seq_in_index"] - 1] = $val["Column_name"];
 }

 reset($res);
 while (list($k, $v) = each($res)) {
 ksort($res[$k]["cols"]);
 }
 
 reset($res);
 }
 
 return $res;
}



function mydb_add_index($tabname, $index, $indexname = "", $indextype = "key", $db = false) {
 global $DB;
 $db = ($db)?$db:$DB;

 if ($db["type"] == "mysql") {
 if ($indextype == "key") {
 $sql = "ALTER TABLE ".sqlf_table($tabname)." ADD INDEX ".sqlf_index($indexname)." (".implode(",",sqlf_field_array($index)).")";
 query($sql,$db);
 }
 } elseif ($db["type"] = "ora") {
 $sql = "CREATE INDEX ".sqlf_index($indexname)." ON ".sqlf_table($tabname)." (".implode(",",sqlf_field_array($index)).")";
 query($sql,$db);
 }

}



function mydb_drop_index($tabname, $indexname, $db = false) {
 global $DB;
 $db = ($db)?$db:$DB;

 if ($db["type"] == "mysql") {
 $sql = "ALTER TABLE ".sqlf_table($tabname)." DROP INDEX ".sqlf_index($indexname);
 query($sql,$db);
 }

}



function mydb_drop_all_indexes($tabname, $indextype = "", $db = false) {
 global $DB;
 $db = ($db)?$db:$DB;

 $rs = mydb_desc_index($tabname, $db);
 while (list($key,$val) = each($rs)) {
 if ($val["type"] == $indextype || $indextype == "") {
 mydb_drop_index($tabname, $key, $db);
 }
 }
 
}



function mydb_optimize_table($tabname, $db = false) {
 global $DB;
 $db = ($db)?$db:$DB;

 if ($db["type"] == "myssql") {
 $sql = "OPTIMIZE TABLE ".sqlf_table($tabname);
 query($sql, $db);
 }
 
}


function mydb_get_jdbc_url($set = NULL) {
 global $SETTINGS;
 if( $set === NULL ) $set = $SETTINGS;
 if( $set['jdbcurl'] ) return $set['jdbcurl'];
 $db = explode(':', $set["server"]);
 $url = "jdbc:".$set["dbtype"]."://".$db[0].":".($db[1] ? $db[1] : "42006")."/".$set["db"];
 if( $set['jdbcparameters'] ) $url .= '?'.$set['jdbcparameters'];
 return $url;
}
function mydb_get_jdbc_driver($set = NULL) {
 global $SETTINGS;
 if( $set === NULL ) $set = $SETTINGS;
 switch( $set['dbtype'] ) {
 case 'mysql': return 'com.mysql.jdbc.Driver';
 case 'ora': return 'oracle.jdbc.driver.OracleDriver';
 }
 return NULL;
}

?>
