<?php

class GUIFactory extends BaseObject {

 function GUIFactory() {
 parent::BaseObject();
 }
 
 function isInitialized() {
 return GUIFactory::_initialized();
 }
 
 



 function &setMainGUI($name) {
 GUIFactory::_mainClass(GUIFactory::_translateToClassName($name));
 GUIFactory::_initialized(true);
 return GUIFactory::getMainGUI();
 }
 
 function &getMainGUI() {
 return GUIFactory::_getGUIObject(GUIFactory::_mainClass(), false);
 }
 
 function getMainGUIName() {
 $main =& GUIFactory::getMainGUI();
 return $main->getGUIName();
 }
 
 function isMainGui( $guiName ) {
 return $guiName == GUIFactory::getMainGUIName();
 }
 
 function &getGUI($name) {
 if (!GUIFactory::_mainClass()) return new NodeException("Main GUI not yet created.");
 $className = GUIFactory::_translateToClassName($name);
 return GUIFactory::_getGUIObject($className, ($className != GUIFactory::_mainClass()));
 }
 
 function getGUIList() {
 return array("main","tree","dialog","menu","stream", "ass", "shell", "frameset", "image" );
 }
 
 function &_getGUIObject($className, $parent) {
 $key = "$className";
 $obj =& GUIFactory::_objects($key);
 if (!is_object($obj)) {
 GUIFactory::_objects($key, GUIFactory::_createGUIObject($className));
 $obj =& GUIFactory::_objects($key);
 }
 if ($parent) {
 $obj->setMainGUI(GUIFactory::getMainGUI());
 }
 return $obj;
 }
 
 function _createGUIObject($className) {
 if ( !$className ) halt( 7, "Cannot create GUI-Object noname. Possibly you didn't set a main-gui" );
 node_class(strtolower($className));
 eval("\$class = new $className();");
 return $class;
 }
 
 function _translateToClassName($key) {
 $key = strtolower($key);
 switch ($key) {
 case "main": $className = "GUIMainObject"; break;
 case "tree": $className = "GUITreeObject"; break;
 case "dialog": $className = "GUIDialogObject"; break;
 case "popup": $className = "GUIPopupDialogObject"; break;
 case "menu": $className = "GUIMenuObject"; break;
 case "stream": $className = "GUIStreamObject"; break;
 case "ass": $className = "GUIAssObject"; break;
 case "shell": $className = "GUIShellObject"; break;
 case "frameset": $className = "GUIFramesetObject"; break;
 case "image": $className = "GUIImageObject"; break;
 default: $className = "NodeException";
 }
 return $className;
 }
 
 
 function &_objects($key, $val = FALSE) {
 static $objects = array();
 if (is_object($val)) $objects[$key] = $val;
 return $objects[$key];
 }

 function &_initialized($val = NULL) {
 static $init = false;
 if ($val !== NULL) $init = $val;
 return $init;
 }

 function &_mainClass($val = NULL) {
 static $main = "";
 if ($val !== NULL) $main = $val;
 return $main;
 }
}

?>
