<?php




class XMLParser extends BaseObject {

 var $xmlcode;
 var $xmlheader;
 var $struct;
 var $code_modified;
 var $struct_modified;
 var $xmlparser;
 var $toLower;
 var $spacer;
 var $parseError;
 var $parseErrorMsg;
 var $parseErrorLine;
 var $parseErrorCol;

 function XMLParser() {
 $this->xmlcode = "";
 $this->xmlheader = "<?xml version='1.0' encoding=\"iso-8859-1\" ?>";
 $this->struct = array();
 $this->struct_modified = true;
 $this->code_modified = true;
 $this->xmlparser = new xml_parser;
 $this->xmlparser->setOuterClass($this);
 $this->toLower = true;
 $this->spacer = "";
 $this->parseError = "";
 }
 
 function setToLower($value) {
 $this->toLower = $value;
 }

 function isToLower() {
 return $this->toLower;
 }

 



 function loadFile($filename) {
 $xml = implode("",file($filename));
 $this->loadXML($xml);
 }

 


 function loadXML($xml) {
 $this->xmlcode = $xml;
 
 $this->code_modified = true;
 }
 
 




 function writeFile($filename) {
 $xml = $this->getXML();
 $fp = @fopen($filename, "w");
 if (!$fp) return false;
 fwrite($fp, $xml);
 fclose($xml);
 return true;
 }

 function setHeader($header) {
 $this->xmlheader = $header;
 $this->struct_modified = true;
 }

 function getHeader() {
 return $this->xmlheader;
 }

 function getStruct() {
 if ($this->code_modified) {
 
 $parser = new xml_parser();
 $parser->setLower($this->toLower);

 if ($parser->parse($this->xmlcode)) {
 
 $this->parseError = $parser->getError();
 $this->parseErrorMsg = $parser->getErrorMessage();
 $this->parseErrorCol = $parser->getErrorCol();
 $this->parseErrorLine = $parser->getErrorLine();
 $this->struct = false;
 } else {
 $this->struct = $parser->getStruct();
 }

 $this->code_modified = false;
 }

 return $this->struct;
 }

 function setStruct($struct) {
 $this->struct = $struct;
 $this->struct_modified = true;
 }

 function getXML() {
 if ($this->struct_modified) {
 
 $xml = $this->xmlheader;

 $xml .= $this->_addXMLParts($this->struct, "");
 
 $this->xmlcode = $xml;
 $this->struct_modified = false;
 }

 return $this->xmlcode;
 }

 function toLower($lower) {
 $this->xmlparser->setLower($lower);
 }

 function isLower() {
 return $this->xmlparser->getLower();
 }
 
 function &getXMLParser() {
 return $this->xmlparser;
 }

 


 function _addXMLParts($struct, $spacer) {
 $xml = "";
 if ( !is_array( $struct ) )
 return "";
 reset($struct);
 while (list($tag, $parts) = each($struct)) {
 reset($parts);
 while (list($key, $part) = each($parts)) {
 
 $xml .= $spacer . "<$tag";
 
 if ( is_array( $part["attributes"] ) ) 
 {
 reset($part["attributes"]);
 while (list($prop, $val) = each($part["attributes"])) {
 $xml .= " ".$prop;
 if ($val !== false) $xml .= "=$val";
 }
 }
 
 if (strtolower($part["type"]) == "complete") {
 $xml .= " />\n";
 } else {
 $xml .= ">";
 
 if (count($part["childs"])) {
 $xml .= "\n";
 $xml .= $this->_addXMLParts($part["childs"], $spacer . $this->spacer);
 }
 if ($part["cdata"]) {
 
 $xml .= "[CDATA[".$part["cdata"]."]]";
 }
 
 if (strpos($part["value"],"\n") !== false) $xml .= ereg_replace("\n[ \t]*$","\n$spacer",$part["value"]);
 elseif (count($part["childs"])) $xml .= $part["value"]."\n".$spacer;
 else $xml .= $part["value"];
 $xml .= "</$tag>\n";
 }
 }
 }
 return $xml;
 }
 
 function isError()
 {
 return $this->parseError != 0;
 }
 
 function getErrorCode()
 {
 return $this->parseError;
 }
 
 function getErrorMessage()
 {
 return $this->parseErrorMsg;
 }
 
 function getErrorLine()
 {
 return $this->parseErrorLine;
 }
 
 function getErrorCol()
 {
 return $this->parseErrorCol;
 }
}

?>
