<?php

















function cmd_update_value($val_text, $val_ref, $info, $tag_type, $tag_id = FALSE,
 $value_id = FALSE, $part_id = FALSE, $static = FALSE, $pageid = FALSE, $change_pagestatus = TRUE) {
 global $FEATURE, $PAGE_ID, $TIME, $T_PAGE, $T_TEMPLATE;

 $hasChanged = true;
 $sqlpart = translate_tagtype($tag_type);
 if ($value_id === FALSE) {
 if ($part_id === FALSE || $tag_id === FALSE) {
 halt(101, "cmd_versionize needs some more information...");
 }
 $where = "part_id = ".sqlf_tl_num($part_id)." AND ".sqlf_field("${sqlpart}_id")." = ".sqlf_tl_num($tag_id);
 if ($tag_type == "construct") {
 $where .= " AND templatetag_id = 0 AND contenttag_id = 0 AND objtag_id = 0";
 }
 } else {
 $where = "id = ".sqlf_tl_num($value_id);
 }
 if ($val_text !== FALSE) {
 $db_val_text = "value_text = '".sqlslashes($val_text)."'";
 }
 if ($val_ref !== FALSE) {
 $db_val_ref = ", value_ref = '".sqlf_escaped($val_ref)."' ";
 }
 if ($info !== FALSE) {
 $db_info = ", info = ".sqlf_tl_num($info);
 }
 $sql = "UPDATE value SET $db_val_text $db_val_ref $db_info ";
 if ($static !== FALSE) {
 $sql .= ", static = ".sqlf_tl_num($static);
 }
 $sql .= " WHERE $where";
 query( $sql );

 if (tagtype_is_page($tag_type) && $change_pagestatus) { 
 if ($pageid === FALSE) {
 $pageid = $PAGE_ID;
 }

 
 node_include("page_status");
 if (!$pageid) {
 $pages = getPageByTagId($tag_type, $tag_id, $value_id);
 } else {
 $pages = array($pageid);
 }
 foreach ($pages as $pid) {
 $hasChanged = set_page_status_after_edit($pid);
 }
 } else if (tagtype_is_objtag($tag_type) && $change_pagestatus) {
 $eventPropertise = array( );
 
 if ($tag_type == "obj") {
 logcmd(W_EDIT, T_OBJTAG, $tag_id, 0, "val_text: " . $val_text . " ref: " . $val_ref);
 $eventProperties['objtag_id'] = $tag_id;
 }
 $sql = "SELECT obj_type, obj_id FROM objtag WHERE id = ".sqlf_tl_num($tag_id);
 $rs = query($sql);
 if ($r = $rs["arr"][0]) {
 node_include("events");
 triggerEvent($r["obj_type"], $r["obj_id"], EVENT_CN_CONTENT | EVENT_CN_OBJPROP, new EventObject($eventProperties));
 }
 }

 clear_cache_for_value($tag_type, $tag_id);
 
 
 return $hasChanged;
}









function cmd_insert_value( $val_text, $val_ref, $info, $tag_type, $tag_id, $part_id, $static=FALSE, $pageid=FALSE, $change_pagestatus = true, $no_cache_clear = true )
{
 global $FEATURE, $PAGE_ID, $USER_ID, $TIME;

 $sqlpart = translate_tagtype( $tag_type );
 $db_val_text = sqlslashes($val_text);
 
 if ( $val_ref !== FALSE ) {
 $c_val_ref = "value_ref, ";
 $db_val_ref = "'".sqlf_escaped($val_ref)."', ";
 }
 if ( $info !== FALSE ) {
 $c_info = "info, ";
 $db_info = "'".sqlf_escaped($info)."', ";
 }
 
 if ( $static !== FALSE ) {
 $c_static = "static, ";
 $db_static = ($static?1:0).", ";
 }
 
 $sql = "INSERT INTO value (value_text, $c_val_ref $c_info $c_static part_id,  ".sqlf_field("${sqlpart}_id").") ".
 "VALUES ('$db_val_text', $db_val_ref $db_info $db_static ".sqlf_tl_num($part_id).", ".sqlf_tl_num($tag_id)." ) ";
 $rs = query( $sql );
 $value_id = $rs["iid"];

 if ( tagtype_is_page( $tag_type ) && $change_pagestatus )
 { 
 if ( $pageid === FALSE ) $pageid = $PAGE_ID;

 
 node_include("page_status");
 if (!$pageid) {
 $pages = getPageByTagId($tag_type, $tag_id, $value_id);
 } else {
 $pages = array($pageid);
 }
 foreach ($pages as $pid) {
 $pageinfo = get_pageinfo($pid);
 if ( $pageinfo["status"] != 0 || $pageinfo["edate"] < $TIME ) {
 if ($FEATURE["tuning_pagesave"] && $FEATURE["contentversion2"]) {
 node_class("cnpageobject");
 $pageobject = new CNPageObject($pid);
 $tmp = $pageobject->diffVersion($TIME,$USER_ID);
 $pagestatus = $pageobject->getFieldValue('status');
 
 if ($pagestatus->d_string == 3 && $tmp) {
 
 page_status($pid, 0);
 
 $status = 3;
 }
 else $status = 0;
 if ($tmp) page_status($pid, $status);
 } else page_status($pid,0);
 }
 }
 } else if ( tagtype_is_objtag( $tag_type ) && $change_pagestatus && $FEATURE["dirt2"] ) {
 $sql = "SELECT obj_type, obj_id FROM objtag WHERE id = ".sqlf_tl_num($tag_id);
 $rs = query($sql);
 if ($r = $rs["arr"][0]) {
 node_include("events");
 triggerEvent($r["obj_type"], $r["obj_id"], EVENT_CN_CONTENT | EVENT_CN_OBJPROP, new EventObject());
 }
 }
 if ( ! $no_cache_clear ) {
 clear_cache_for_value($tag_type, $tag_id);
 }
 return $value_id;
}




function clear_cache_for_value($tag_type, $tag_id) {
 global $FEATURE;

 if( $FEATURE['javaparser'] ) {
 $ttype = NULL;
 if($tag_type == "content") $ttype = T_CONTENTTAG;
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($ttype, $tag_id);
 }
}







function duplicateNonstaticDatasource($id, $partId) {
 if (!$partId) {
 return $id;
 }

 
 $sql = "SELECT type_id FROM part WHERE id = ".sqlf_tl_num($partId);
 $rs = query($sql);
 if ($rs["num"] == 0) {
 return $id;
 } else if ($rs["arr"][0]["type_id"] != 32) {
 return $id;
 }

 $sql = "SELECT id FROM datasource WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);

 if ($rs["num"] == 0) {
 return false;
 }

 $sql = "INSERT INTO datasource (source_type, param_id) SELECT source_type, param_id FROM datasource WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $newId = $rs["iid"];

 if (!$newId) {
 halt(7, "Unable to duplicate datasource $id");
 }

 $sql = "INSERT INTO datasource_value (datasource_id, sorder, dskey, value, dsid) SELECT ".sqlf_tl_num($newId).", sorder, dskey, value, dsid FROM datasource_value WHERE datasource_id = ".sqlf_tl_num($id);
 query($sql);

 return $newId;
}

?>
