<?php

function endsWith($haystack, $needle)
{
 return $needle === "" || substr($haystack, -strlen($needle)) === $needle;
}






function convertToFilename($filename, $defaultExtension) {
 global $FEATURE;
 global $SANITIZE_CHARACTER;
 global $SANITIZE_REPLACEMENT_CHARACTER;
 global $SANITIZE_ALLOWED_CHARACTERS;
 $filename = trim($filename);

 $actualExtension = "";
 if (endsWith($filename, $defaultExtension)) {
 $actualExtension = $defaultExtension;
 } else {
 $t_pathinfo = pathinfo($filename);
 if ($t_pathinfo['extension']) {
 $actualExtension = '.' . $t_pathinfo['extension'];
 }
 }
 if ($actualExtension) {
 $filename = substr($filename, 0, - strlen($actualExtension));
 }
 if (!$filename) {
 return "";
 }

 $maxFilenameLength = 64;
 $allowedCharactersRegex = '[^A-Za-z0-9_ \.\-\(\)\[\]{}$#insert#]';
 if( $FEATURE['filename_forcetolower'] ) {
 $filename = strtolower($filename);
 }

 $sanitizeKeys = array_keys($SANITIZE_CHARACTER);

 
 $filename = str_replace(
 $sanitizeKeys,
 array_values($SANITIZE_CHARACTER),
 $filename
 );

 if (empty($SANITIZE_ALLOWED_CHARACTERS)) {
 $allowedCharactersRegex = preg_replace('/#insert#/','',$allowedCharactersRegex);
 } else {
 $regexExtraChars = preg_quote(implode(array_values($SANITIZE_ALLOWED_CHARACTERS)));
 $allowedCharactersRegex = preg_replace('/#insert#/',$regexExtraChars,$allowedCharactersRegex);
 }
 
 mb_internal_encoding('UTF-8');
 mb_regex_encoding('UTF-8');
 $filename = mb_ereg_replace($allowedCharactersRegex, $SANITIZE_REPLACEMENT_CHARACTER, $filename);

 if ($actualExtension) {
 $filename = $filename . $actualExtension;
 }

 
 if (strlen($filename) > $maxFilenameLength) {

 $pathInfo = pathinfo($filename);

 if (isset($pathInfo['extension'])) {
 $extension = $pathInfo['extension'];
 }
 else {
 $extension = "";
 }

 
 
 if (!isset($pathInfo['filename'])){
 $pathInfo['filename'] = substr($pathInfo['basename'], 0, strpos($pathInfo['basename'], '.'));
 }

 $hasExtension = (strlen($extension) > 0 || substr($pathInfo['filename'], -1) == '.');
 $newFileNameLength = $maxFilenameLength - strlen($extension);

 if ($hasExtension) {
 $newFileNameLength--;
 }

 if ($newFileNameLength > 0) {
 $filename = mb_strcut($pathInfo['filename'], 0, $newFileNameLength);

 if ($hasExtension) {
 $filename .= '.' . $extension;
 }
 }

 if (strlen($filename) > $maxFilenameLength) {
 
 $filename = mb_strcut($filename, 0, $maxFilenameLength);
 }
 }
 if(0 === strpos($filename,'.')){
 $filename = "1" . $filename;
 }
 return $filename;
}
