<?php

if ($USER_ID !== 1) {
 exit();
}

GUIFactory::setMainGUI( "main" );

if ($cmd == "fix") {
 $clearCache = false;
 $files = getFilesInMaster();
 $filesInMasterBeforeFix = "<b>fixed from ".count($files)."</b> -&gt; ";
 foreach ( $files as $file ) {
 fixObject("contentfile", $file["id"], $file["channel_id"]);
 $clearCache = true;
 }

 $pages = getPagesInMaster();
 $pagesInMasterBeforeFix = "<b>fixed from ".count($pages)."</b> -&gt; ";
 foreach ($pages as $page) {
 fixObject("page", $page["id"], $page["channel_id"]);
 $clearCache = true;
 }

 $folders = getFoldersInMaster();
 $foldersInMasterBeforeFix = "<b>fixed from ".count($folders)."</b> -&gt; ";
 foreach ( $folders as $folder ) {
 fixObject("folder", $folder["id"], $folder["channel_id"]);
 $clearCache = true;
 }

 if ($clearCache) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache("ALL", "ALL");
 }
}


$filesInMaster = countFilesInMaster();
$pagesInMaster = countPagesInMaster();
$foldersInMaster = countFoldersInMaster();




function fixObject($table, $id, $channelId) {
 
 $variant = query("select id from ".sqlf_name($table)." where channelset_id = (SELECT channelset_id FROM ".sqlf_name($table)." WHERE id = ".sqlf_value($id)." AND channelset_id != 0) AND channel_id = ".sqlf_value($channelId));
 if ($variant["num"] > 0) {
 
 } else {
 query("UPDATE ".sqlf_name($table)." set channel_id = ".sqlf_value($channelId)." WHERE id = ".sqlf_value($id));
 }
}





function countFilesInMaster() {
 $rs = query("select count(*) c from contentfile left join folder on contentfile.folder_id = folder.id where contentfile.channel_id = 0 and folder.channel_id != 0");
 return $rs["arr"][0]["c"];
}





function getFilesInMaster() {
 $rs = query("SELECT contentfile.id, folder.channel_id FROM contentfile left join folder on contentfile.folder_id = folder.id where contentfile.channel_id = 0 and folder.channel_id != 0");
 return $rs["arr"];
}





function countPagesInMaster() {
 $rs = query("select count(*) c from page left join folder on page.folder_id = folder.id where page.channel_id = 0 and folder.channel_id != 0");
 return $rs["arr"][0]["c"];
}





function getPagesInMaster() {
 $rs = query("select page.id, folder.channel_id from page left join folder on page.folder_id = folder.id where page.channel_id = 0 and folder.channel_id != 0");
 return $rs["arr"];
}





function countFoldersInMaster() {
 $rs = query("select count(*) c from folder f left join folder m on f.mother = m.id where f.channel_id = 0 and m.channel_id != 0");
 return $rs["arr"][0]["c"];
}





function getFoldersInMaster() {
 $rs = query("select f.id, m.channel_id from folder f left join folder m on f.mother = m.id where f.channel_id = 0 and m.channel_id != 0");
 return $rs["arr"];
}
