-- MySQL dump 10.10
--
-- Host: localhost    Database: hp_contentrepository
-- ------------------------------------------------------
-- Server version	4.1.21-standard

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `contentattribute`
--

DROP TABLE IF EXISTS `contentattribute`;
CREATE TABLE `contentattribute` (
  `id` int(11) NOT NULL auto_increment,
  `contentid` varchar(32) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `value_text` mediumtext,
  `value_bin` mediumblob,
  `value_int` int(11) default NULL,
  `sortorder` int(11) default NULL,
  `value_blob` longblob,
  `value_clob` mediumtext,
  `value_long` bigint(20) default NULL,
  `value_double` double default NULL,
  `value_date` datetime default NULL,
  PRIMARY KEY  (`id`),
  KEY `contentid` (`contentid`),
  KEY `name` (`name`),
  KEY `contentid_2` (`contentid`,`name`)
) ENGINE=MyISAM AUTO_INCREMENT=1034 DEFAULT CHARSET=utf8;

--
-- Dumping data for table `contentattribute`
--


/*!40000 ALTER TABLE `contentattribute` DISABLE KEYS */;
LOCK TABLES `contentattribute` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `contentattribute` ENABLE KEYS */;

--
-- Table structure for table `contentattribute_nodeversion`
--

DROP TABLE IF EXISTS `contentattribute_nodeversion`;
CREATE TABLE `contentattribute_nodeversion` (
  `id` int(11) NOT NULL default '0',
  `contentid` varchar(32) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `value_text` mediumtext,
  `value_bin` mediumblob,
  `value_int` int(11) default NULL,
  `sortorder` int(11) default NULL,
  `value_blob` longblob,
  `nodeversiontimestamp` int(11) default NULL,
  `nodeversion_user` varchar(100) default NULL,
  `nodeversionlatest` int(11) default NULL,
  `nodeversionremoved` int(11) default NULL,
  `nodeversion_autoupdate` tinyint(4) NOT NULL default '0',
  `value_clob` mediumtext,
  `value_long` bigint(20) default NULL,
  `value_double` double default NULL,
  `value_date` datetime default NULL,
  KEY `id_2` (`id`,`nodeversiontimestamp`),
  KEY `contentid_2` (`contentid`,`name`),
  KEY `sortorder` (`sortorder`),
  KEY `contentid_3` (`contentid`,`name`(100),`value_text`(100)),
  KEY `contentid` (`contentid`),
  KEY `id` (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `contentattribute_nodeversion`
--


/*!40000 ALTER TABLE `contentattribute_nodeversion` DISABLE KEYS */;
LOCK TABLES `contentattribute_nodeversion` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `contentattribute_nodeversion` ENABLE KEYS */;

--
-- Table structure for table `contentattributetype`
--

DROP TABLE IF EXISTS `contentattributetype`;
CREATE TABLE `contentattributetype` (
  `name` varchar(32) default NULL,
  `attributetype` int(11) default NULL,
  `optimized` int(11) default NULL,
  `quickname` varchar(255) default NULL,
  `multivalue` int(11) NOT NULL default '0',
  `objecttype` int(11) NOT NULL default '0',
  `linkedobjecttype` int(11) NOT NULL default '0',
  `foreignlinkattribute` varchar(255) NOT NULL default '',
  `foreignlinkattributerule` mediumtext,
  `exclude_versioning` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `contentattributetype`
--


/*!40000 ALTER TABLE `contentattributetype` DISABLE KEYS */;
LOCK TABLES `contentattributetype` WRITE;
INSERT INTO `contentattributetype` VALUES ('creator',2,0,NULL,0,1006,1001,'','',0),('commentString',1,0,NULL,0,1006,0,'','',0),('todo',2,0,NULL,0,1006,1005,'','',0),('commentDate',10,0,NULL,0,1006,0,'','',0),('created',10,0,NULL,0,1005,0,'','',0),('subject',1,0,NULL,0,1005,0,'','',0),('description',5,0,NULL,0,1005,0,'','',0),('type',1,0,NULL,0,1005,0,'','',0),('references',5,0,NULL,0,1005,0,'','',0),('extended_info',5,0,NULL,0,1005,0,'','',0),('receiver',2,0,NULL,1,1005,1001,'','',0),('creator',2,0,NULL,0,1005,1001,'','',0),('deadline',10,0,NULL,0,1005,0,'','',0),('history',7,0,NULL,0,1005,1011,'todo','',0),('status',1,0,NULL,0,1005,0,'','',0),('pageid',1,0,NULL,0,1005,0,'','',0),('comments',7,0,NULL,0,1005,1006,'todo','',0),('file',7,0,NULL,0,1005,1010,'todo','',0),('new',3,0,NULL,0,1005,0,'','',0),('date',10,0,NULL,0,1011,0,'','',0),('status',1,0,NULL,0,1011,0,'','',0),('filesize',8,0,NULL,0,1010,0,'','',0),('todo',2,0,NULL,0,1010,1005,'','',0),('content',6,0,NULL,0,1010,0,'','',0),('filename',1,0,NULL,0,1010,0,'','',0),('contenttype',1,0,NULL,0,1010,0,'','',0),('usergroupid',1,0,NULL,0,1009,0,'','',0),('name',1,0,NULL,0,1009,0,'','',0),('description',5,0,NULL,0,1009,0,'','',0),('parent',2,0,NULL,0,1009,1009,'','',0),('users',7,0,NULL,0,1009,1001,'groups','',0),('children',7,0,NULL,0,1009,1009,'parent','',0),('groups',2,0,NULL,1,1001,1009,'','',0),('pwd',1,0,NULL,0,1001,0,'','',0),('login',1,0,NULL,0,1001,0,'','',0),('name',1,0,NULL,0,1001,0,'','',0),('userid',1,0,NULL,0,1001,0,'','',0),('email',1,0,NULL,0,1001,0,'','',0),('nodeid',1,0,NULL,0,1012,0,'','',0),('contentgroups',2,0,NULL,1,1012,1013,'','',0),('name',1,0,NULL,0,1013,0,'','',0),('code',1,0,NULL,0,1013,0,'','',0),('contentgroupid',1,0,NULL,0,1013,0,'','',0),('node',7,0,NULL,0,1013,1012,'contentgroups','',0),('creatorname',1,0,NULL,0,1005,0,'',NULL,0),('active','1',0,null,0,1001,0,0,null,0);
INSERT INTO `contentattributetype` (name, attributetype, objecttype) values ('extlink', 1, 1005);
UNLOCK TABLES;
/*!40000 ALTER TABLE `contentattributetype` ENABLE KEYS */;

--
-- Table structure for table `contentmap`
--

DROP TABLE IF EXISTS `contentmap`;
CREATE TABLE `contentmap` (
  `id` int(11) NOT NULL auto_increment,
  `contentid` varchar(32) NOT NULL default '',
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` int(11) NOT NULL default '0',
  `mother_obj_id` int(11) NOT NULL default '0',
  `mother_obj_type` int(11) NOT NULL default '0',
  `updatetimestamp` int(11) NOT NULL default '0',
  `motherid` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `obj_id` (`obj_id`),
  KEY `obj_type` (`obj_type`),
  KEY `motherid` (`motherid`,`contentid`),
  KEY `contentid` (`contentid`)
) ENGINE=MyISAM AUTO_INCREMENT=216 DEFAULT CHARSET=utf8;

--
-- Dumping data for table `contentmap`
--


/*!40000 ALTER TABLE `contentmap` DISABLE KEYS */;
LOCK TABLES `contentmap` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `contentmap` ENABLE KEYS */;

--
-- Table structure for table `contentmap_nodeversion`
--

DROP TABLE IF EXISTS `contentmap_nodeversion`;
CREATE TABLE `contentmap_nodeversion` (
  `id` int(11) NOT NULL default '0',
  `contentid` varchar(32) NOT NULL default '',
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` int(11) NOT NULL default '0',
  `motherid` varchar(32) NOT NULL default '',
  `mother_obj_id` int(11) NOT NULL default '0',
  `mother_obj_type` int(11) NOT NULL default '0',
  `updatetimestamp` int(11) NOT NULL default '0',
  `nodeversiontimestamp` int(11) default NULL,
  `nodeversion_user` varchar(100) default NULL,
  `nodeversionlatest` int(11) default NULL,
  `nodeversionremoved` int(11) default NULL,
  `nodeversion_autoupdate` tinyint(4) NOT NULL default '0',
  KEY `obj_id` (`obj_id`),
  KEY `id` (`id`),
  KEY `obj_type` (`obj_type`),
  KEY `motherid_2` (`motherid`),
  KEY `contentid` (`contentid`),
  KEY `motherid` (`motherid`,`contentid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `contentmap_nodeversion`
--


/*!40000 ALTER TABLE `contentmap_nodeversion` DISABLE KEYS */;
LOCK TABLES `contentmap_nodeversion` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `contentmap_nodeversion` ENABLE KEYS */;

--
-- Table structure for table `contentobject`
--

DROP TABLE IF EXISTS `contentobject`;
CREATE TABLE `contentobject` (
  `name` varchar(32) default NULL,
  `type` int(11) NOT NULL default '0',
  `id_counter` int(11) NOT NULL default '0',
  `exclude_versioning` int(11) NOT NULL default '0',
  PRIMARY KEY  (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `contentobject`
--


/*!40000 ALTER TABLE `contentobject` DISABLE KEYS */;
LOCK TABLES `contentobject` WRITE;
INSERT INTO `contentobject` VALUES ('todo_comment',1006,43,0),('todo',1005,51,0),('todo_history',1011,55,0),('todo_file',1010,3,0),('usergroup',1009,10,0),('user',1001,11,0),('node',1012,5,0),('contentgroup',1013,6,0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `contentobject` ENABLE KEYS */;

--
-- Table structure for table `contentstatus`
--

DROP TABLE IF EXISTS `contentstatus`;
CREATE TABLE `contentstatus` (
  `name` char(255) NOT NULL default '',
  `intvalue` int(11) default NULL,
  PRIMARY KEY  (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `contentstatus`
--


/*!40000 ALTER TABLE `contentstatus` DISABLE KEYS */;
LOCK TABLES `contentstatus` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `contentstatus` ENABLE KEYS */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

INSERT INTO `contentattributetype` (`name`,`attributetype`,`optimized`,`quickname`,`multivalue`,`objecttype`,`linkedobjecttype`,`foreignlinkattribute`,`foreignlinkattributerule`,`exclude_versioning`) VALUES
  ('extended_info',5,NULL,NULL,0,1015,0,'',NULL,0);
INSERT INTO `contentattributetype` (`name`,`attributetype`,`optimized`,`quickname`,`multivalue`,`objecttype`,`linkedobjecttype`,`foreignlinkattribute`,`foreignlinkattributerule`,`exclude_versioning`) VALUES
  ('name',1,NULL,NULL,0,1014,0,'',NULL,0);
INSERT INTO `contentattributetype` (`name`,`attributetype`,`optimized`,`quickname`,`multivalue`,`objecttype`,`linkedobjecttype`,`foreignlinkattribute`,`foreignlinkattributerule`,`exclude_versioning`) VALUES
  ('items',7,0,NULL,0,1014,1015,'translationlistid','',0);
INSERT INTO `contentattributetype` (`name`,`attributetype`,`optimized`,`quickname`,`multivalue`,`objecttype`,`linkedobjecttype`,`foreignlinkattribute`,`foreignlinkattributerule`,`exclude_versioning`) VALUES
  ('userid',1,NULL,NULL,0,1014,0,'',NULL,0);
INSERT INTO `contentattributetype` (`name`,`attributetype`,`optimized`,`quickname`,`multivalue`,`objecttype`,`linkedobjecttype`,`foreignlinkattribute`,`foreignlinkattributerule`,`exclude_versioning`) VALUES
  ('receiver',2,NULL,NULL,1,1015,1001,'',NULL,0);
INSERT INTO `contentattributetype` (`name`,`attributetype`,`optimized`,`quickname`,`multivalue`,`objecttype`,`linkedobjecttype`,`foreignlinkattribute`,`foreignlinkattributerule`,`exclude_versioning`) VALUES
  ('translationlistid',2,0,NULL,0,1015,1014,'','',0);

INSERT INTO `contentobject` (`name`,`type`,`id_counter`,`exclude_versioning`) VALUES
  ('translationlist',1014,54,0);
INSERT INTO `contentobject` (`name`,`type`,`id_counter`,`exclude_versioning`) VALUES
  ('translationlistitem',1015,51,0);
INSERT INTO `contentattributetype` (`name`,`attributetype`,`optimized`,`quickname`,`multivalue`,`objecttype`,`linkedobjecttype`,`foreignlinkattribute`,`foreignlinkattributerule`,`exclude_versioning`) VALUES
  ('contentgroup_id',2,0,NULL,0,1005,1013,'','',0);
INSERT INTO `contentattributetype` (`name`,`attributetype`,`optimized`,`quickname`,`multivalue`,`objecttype`,`linkedobjecttype`,`foreignlinkattribute`,`foreignlinkattributerule`,`exclude_versioning`) VALUES
  ('contentgroup_id',2,0,NULL,0,1015,1013,'','',0);

INSERT INTO `contentattributetype` (`name`,`attributetype`,`optimized`,`quickname`,`multivalue`,`objecttype`,`linkedobjecttype`,`foreignlinkattribute`,`foreignlinkattributerule`,`exclude_versioning`) VALUES
  ('user_id',2,0,NULL,0,1011,1001,'','',0);


-- Optimize some columns
ALTER TABLE contentmap ADD quick_created datetime default NULL;
ALTER TABLE contentmap ADD INDEX (quick_created);
UPDATE contentmap m SET quick_created = (SELECT value_date FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'created' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_created' WHERE name = 'created';

ALTER TABLE contentmap ADD quick_deadline datetime default NULL;
ALTER TABLE contentmap ADD INDEX (quick_deadline);
UPDATE contentmap m SET quick_deadline = (SELECT value_date FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'deadline' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_deadline' WHERE name = 'deadline';

ALTER TABLE contentmap ADD quick_subject mediumtext;
ALTER TABLE contentmap ADD INDEX (quick_subject (255));
UPDATE contentmap m SET quick_subject = (SELECT value_text FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'subject' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_subject' WHERE name = 'subject';

ALTER TABLE contentmap ADD quick_type mediumtext;
ALTER TABLE contentmap ADD INDEX (quick_type (255));
UPDATE contentmap m SET quick_type = (SELECT value_text FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'type' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_type' WHERE name = 'type';

ALTER TABLE contentmap ADD quick_status mediumtext;
ALTER TABLE contentmap ADD INDEX (quick_status (255));
UPDATE contentmap m SET quick_status = (SELECT value_text FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'status' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_status' WHERE name = 'status';

ALTER TABLE contentmap ADD quick_description mediumtext;
ALTER TABLE contentmap ADD INDEX (quick_description (255));
UPDATE contentmap m SET quick_description = (SELECT value_clob FROM contentattribute a WHERE a.contentid = m.contentid AND a.name = 'description' LIMIT 1);
UPDATE contentattributetype SET optimized = 1, quickname = 'quick_description' WHERE name = 'description';
